# Deployer recipe for OXID 6.5.x + 7.x

This project uses [Deployer](https://deployer.org/) for scripted installation

### Server setup

Install [Composer](https://getcomposer.org/).

Run the command `composer create-project --dev d3/oxid-deployer-project deployer ^1.0`

After that, add an alias for the deployer command: `alias dep='/usr/local/php8.2/bin/php /home/XXX/deployer/vendor/bin/dep'` and reload the changed configuration.

Rename `inventory.yml.dist` to `inventory.yml` and change project settings in it. 

Make sure, that Deployer has at least read access to the customers repository.

Commit changed files in the customers repository.

### Update Deployer

- `cd deployer`
- `composer update`
- apply changes in the `inventory.yml`
- commit changes

## Project

### Deployment

- `cd deployer`
- `dep deploy [stage]`

### Rollback

... in case of errors after successful deployment

This command set `current` directory to previous deployment:

- `dep rollback [stage]`

## Other available tasks

- dep `shop:getVersion` [stage] - show version of current OXID installation
- dep `shop:cloneDatabase` [stage] - dump contents from source to destination database
- dep `shop:runMigration` [stage] - run all database migrations
- dep `setup:createDbConfig` [stage] - generate database configuration file
- dep `list` - list all available commands
- dep `releases` - lists all releases of the selected host
- dep `run` - run any command in the current release of the selected host (e.g. `dep run 'echo {{bin/composer}}'` for full Composer command)